# Remote scope

A *remote scope* is a configuration setting in SpecSync that defines the set of Jira Test Cases that are to be considered for synchronization from a particular SpecSync configuration.

The primary purpose of the remote scope is to detect if a local test case has been removed, for example when a scenario has been deleted from a feature file (see details [below](#processing-removed-local-test-cases)). The remote scope is also used for [pull command](/specsync/jira/features/pull-features/two-way-synchronization.md#creating-new-scenarios-from-test-cases) to create new local test cases based on Jira Test Cases.

Configuring a remote scope is optional, but recommended. If no remote scope is configured SpecSync will not be able to detect removed local test cases and the related option for the pull command will not be available.

The remote scope is configured using the `remote/scope` configuration section. When configuring the remote scope, you can choose from different options on how the remote scope should be maintained by SpecSync. When changing the remote scope configuration, you need to perform a full (unfiltered) *push* synchronization so that the remote scope is established.

{% hint style="warning" %}
This feature has been significantly improved in SpecSync v5 and the configuration has been changed. In earlier versions only `testSuite` remote scope type was available that was configured using the `remote/testSuite` configuration setting. For trying out the new extended behavior, please check the [preview version of v5](/specsync/jira/changelog.md#v5).
{% endhint %}

The following configuration file configures a *tag remote scope*.

{% code title="specsync.json" %}

```json
{
  "$schema": "https://schemas.specsolutions.eu/specsync4azuredevops-config-v5-latest.json",
  "compatibilityVersion": "5",
  "configurationKey": "my-project-config",
  "remote": {
    "projectUrl": "[...]",
    "scope": {
      "type": "tag"
    }
  },
  ...
}
```

{% endcode %}

The following table contains an overview of the possible options. Please check the section [How to choose remote scope type](#how-to-choose-remote-scope-type) for help to decide.

| Type  | Description                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                 |
| ----- | --------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------- |
| `tag` | The Jira Test Cases in the remote scope are marked with the tag `specsync:<config-key>` (this is a remote-only tag, it will not be synchronized to a local tag during *pull*). The advantage of this remote scope type that it is easy to know from a Test Case that it was synchronized from a particular SpecSync configuration and you can also use the tag for querying Test Cases in Jira. In order to use the *pull* command for crating new local tests from Jira Test Cases, the new Test Cases can be added manually to the remote scope by adding the tag to the Test Case. The disadvantage is that the additional Jira tag might be disturbing. In order to use this remote scope type you need to specify a [configuration key](/specsync/jira/features/common-synchronization-features/configuration-key.md). |

## How to choose remote scope type

For Jira currently only the `tag` remote scope type is available. We recommend to use that.

## Processing removed local test cases

As mentioned above the the primary purpose of the remote scope is to detect if a local test case has been removed, for example when a scenario has been deleted from a feature file.

This detection is performed during *push* synchronization in a way that SpecSync loads the Test Case IDs that are in remote scope and matches them to the processed local test cases (e.g. scenarios) as the following example shows.

![Remote scope is used to detect removed scenario](/files/NDv3ThbA5JTFS3AjVnnR)

In this example, the Test Case #12 is in the remote scope, because SpecSync has included it earlier when the related scenario was synchronized. The scenario has been removed from the feature file, so SpecSync will not find a matching scenario for Test Case #12 therefore it is considered to be removed.

### Tagging removed Test Cases

{% hint style="success" %}
SpecSync never deletes Jira Test Cases to avoid data loss.
{% endhint %}

The Test Cases corresponding to the deleted local test are not deleted from Jira to avoid data loss, but they are tagged with `specsync:removed`. The tagged Test Cases can be deleted by the user in Jira if they are not required anymore.

If the SpecSync configuration has a [configuration key](/specsync/jira/features/common-synchronization-features/configuration-key.md) specified, the removed Test Cases will be tagged with a `specsync:removed-from:<config-key>` tag in addition to `specsync:removed`. This can help identifying which configuration was used to synchronize this Test Case earlier.

### Excluding removed Test Case from hierarchies

SpecSync can synchronize Test Cases into hierarchical structures using the [Test Case hierarchies](/specsync/jira/features/common-synchronization-features/synchronizing-test-case-hierarchies.md) feature. These structures are also maintained with removed test cases if remote scopes are used.

This means that whenever SpecSync detects a test case as removed, it will excluded it from any Test Case hierarchy it was previously included in.

### Detection of removed test cases with filtered synchronization

The *push* synchronization can be limited to a smaller set of test cases using the [`--filter` command line option](/specsync/jira/reference/command-line-reference/push-command.md). This is usually used to quickly synchronize the set of the test cases the user is currently working on and not to check if test cases have been removed from the entire configuration.

Therefore **by default SpecSync the removed test detection is disabled when a filtered synchronization is performed**.

This behavior can be modified by setting the `toolSettings/forceProcessingRemovalsOnFilter` configuration option to `true`.

### Undo removal

Thanks to the fact that SpecSync does not delete, but only tag the removed Test Cases, the removal is reversible.

If the removed local test case (scenario) is restored and a *push* synchronization is performed, SpecSync will detect that there is already a Test Case corresponding to the restored local test case and it simply removes the added `specsync:removed` and `specsync:removed-from:<config-key>` tags. The restored Test Case will be included again to the remote scope and to any [Test Case hierarchies](/specsync/jira/features/common-synchronization-features/synchronizing-test-case-hierarchies.md) it has been removed from. With that the original state is restored.


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.specsolutions.eu/specsync/jira/features/common-synchronization-features/remote-scope.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
